 /**
 * Enhanced Google Analytics tracking (eGA).
 * Adds special capabilities to your common GA tracking.
 *
 * @summary   Enhanced Google Analytics tracking (eGA). Beta version.
 *
 * @link      http://www.brunoamaral.pt/
 * @since     0.0.1
 * @class     eGA
 * @classdesc This is a description of the MyClass class.
 * @author    Bruno Amaral
 */
var eGA=function(local_domains=false,time_interval=10){this.scrollpos_x=this.scrollpos_y=0;this.mousepos_x=this.mousepos_y=0;this.time_on_page=0;this.time_interval=time_interval;this.scroll_timer=null;this.local_domains=new Array(location.hostname);var self_eGA=this;this.getScrollY=function(){var scrollPosition='pageYOffset'in window?window.pageYOffset:document.body.scrollTop;return scrollPosition;}
this.getScrollX=function(){var scrollPosition='pageXOffset'in window?window.pageXOffset:document.body.scrollLeft;return scrollPosition;}
this.getHeight=function(){var _docHeight=(document.height!==undefined)?document.height:document.body.offsetHeight;var _docWidth=(document.width!==undefined)?document.width:document.body.offsetWidth;console.log(_docWidth+' x '+_docHeight);}
this.track_time=function(){self_eGA.time_on_page+=self_eGA.time_interval;console.log('Track Time: '+self_eGA.time_on_page);ga('send','event','Usage','Time',self_eGA.time_on_page+'s');}
this.track_file_download=function(file_type,obj){console.log('Track File Download');ga('send','event','Usage','Download '+file_type,(obj.innerHTML.textContent||obj.innerHTML.innerText));}
this.track_external_link=function(url,obj){console.log('Track External Link');ga('send','event','Usage','External Link',url);}
this.track_scroll=function(event,track){console.log('Scroll');if(!track){if(!this.scroll_timer){this.scroll_timer=setTimeout(function(event){self_eGA.track_scroll(event,true);},250);console.log('timer');}
return false;}
else{this.scroll_timer=null;}
console.log('Track Scroll');var scroll_top=this.getScrollY();console.log('Scroll: '+scroll_top);var viewport_height=$(window).height();console.log('Window height: '+viewport_height);var page_height=$(document).height();console.log('Height: '+page_height);var scroll_percentage=Math.round((scroll_top /(page_height-viewport_height))*100,2);console.log('Percentage: '+scroll_percentage);ga('send','event','Usage','Scroll',scroll_percentage+'%');return true;}
this.start=function(alreadyused){console.log("Main");if(typeof ga==='function'){console.log(ga);console.log('ga is function');}
else{setTimeout(function(alreadyused){self_eGA.start(alreadyused);},100);return false;}
console.log('Time'+self_eGA.time_interval);setInterval(self_eGA.track_time,self_eGA.time_interval*1000);jQuery('a[href$=".pdf"]').click(function(){self_eGA.track_file_download('PDF',this);});jQuery('a[href$=".doc"],a[href$=".docx"]').click(function(){self_eGA.track_file_download('DOC',this);});jQuery('a[href$=".xls"],a[href$=".xlsx"]').click(function(){self_eGA.track_file_download('XLS',this);});jQuery('a[href$=".zip"]').click(function(){self_eGA.track_file_download('ZIP',this);});jQuery('a').click(function(){console.log(this.hostname);if(self_eGA.local_domains.indexOf(this.hostname)==-1){self_eGA.track_external_link('ZIP',this);}
return false;});jQuery(window).scroll(self_eGA.track_scroll);return true;}
var scripts=document.getElementsByTagName("script");var script=scripts[scripts.length-1];console.log(script.src);for(var i=0,len=scripts.length;i<len;i++){if(scripts[i].getAttribute("src")==null){continue;}
else{var src=scripts[i].getAttribute("src").split("?");var url=src[0];var args=src[1];if(url.indexOf("ega.js")==-1){continue;}}
if(!args){continue;}
else{var argv=args.split("&");console.log(argv);for(var j=0,argc=argv.length;j<argc;j++){var pair=argv[j].split("=");var argName=pair[0];var argValue=pair[1];console.log(argName);switch(argName){case"domains":this.local_domains=argValue;break;case"time_interval":this.time_interval=parseInt(argValue);break;default:continue;}}}}
console.log(local_domains);if(local_domains){if(Array.isArray(local_domains)){this.local_domains=local_domains;}
else if(local_domains.indexOf(',')>-1){this.local_domains=local_domains.split(',');}
else{this.local_domains=[local_domains];if(local_domains.indexOf('www.')>-1){this.local_domains.push(local_domains.replace(/www\./,''));}
else{this.local_domains.push('www.'+local_domains);}}}
console.log('Domains: '+this.local_domains.toString());if(typeof jQuery==="undefined"||jQuery.fn.jquery!=='1.7.1'){console.log('Load jQuery');var script_tag=document.createElement('script');script_tag.setAttribute("type","text/javascript");script_tag.setAttribute("src","http://ajax.googleapis.com/ajax/libs/jquery/1.7.1/jquery.min.js")
script_tag.onload=self_eGA.start;script_tag.onreadystatechange=function(){if(this.readyState=='complete'||this.readyState=='loaded')self_eGA.start(2);}
document.getElementsByTagName("head")[0].appendChild(script_tag);}else{console.log('jQuery already loaded');this.start(1);}}
new eGA();